cat <<EOF
This script will create the tables and load an exceptionally simple
data set that will allow you to test if the cfengine is working properly
with the text-based console client (bin/cf_client)

EOF

# Table names are set in config.sh
CF_PATH=`dirname $0`/../..
export CF_PATH
. $CF_PATH/config.sh

cat <<EOF
This action will destroy all cfengine-related tables in the 
database '$SqlDbName', if such a database already exists. 

****Are you sure you want to continue? (Y/N)
EOF

read ans

case $ans in 
	Y|y|yes|Yes|YES) 
		echo "Proceeding..."
	 ;;
	*)
		exit 1;	
	;;
esac

# Table names are set in config.sh
CF_PATH=`dirname $0`/../..
export CF_PATH
. $CF_PATH/config.sh

echo "Running 'bin/initialize_tables'"
$CF_PATH/bin/initialize_tables.sh -f

echo "Running 'bin/load_data.sh'"
$CF_PATH/bin/load_data.sh -f $CF_PATH/Data/simple/ratingdata.txt \
	-t $CF_PATH/Data/simple/itemtype.txt

echo
echo "Creating and loading DB tables needed for client only"

echo "   Creating and loading table mapping item names(text) to item ids"
$CF_PATH/bin/java_jdbc/make_item_db $CF_PATH/Data/simple/itemdata.txt

echo "   Creating and loading table mapping item category names(text) to category ids"
$CF_PATH/bin/java_jdbc/make_type_db $CF_PATH/Data/simple/type.txt

echo "   Creating and loading table mapping item category names(text) to category ids"
$CF_PATH/bin/java_jdbc/make_user_db $CF_PATH/Data/simple/userdata.txt

