#!/bin/sh
#
# This script is meant to be run from cron every night. 
# It does a cvs update, runs configure, then does a make, then rebuilds the 
# javadoc. Eventually, it may also run the tests. 
#
cvs update -A -d

gmake clean
if test $? -ne 0; then
        echo "Nightly Build: gmake javadoc Failed!"
        exit 1
fi

./configure
if test $? -ne 0; then
	echo "Nightly Build: Configure Failed!"
	exit 1
fi

# We build the JavaDoc before we build the code
# so that the javadoc doesn't include the automatically
# generated code (RMI/Corba stubs)
gmake javadoc
if test $? -ne 0; then
        echo "Nightly Build: gmake javadoc Failed!"
        exit 1
fi

gmake
if test $? -ne 0; then
        echo "Nightly Build: gmake Failed!"                                 
        exit 1
fi

chmod 775 .
chmod 775 Docs
find Docs -type d -print | xargs chmod o+x
chmod -R o+r Docs
exit 0
