#!/bin/sh

####################################################################
# shell command for building the mysql database.
####################################################################


Usage="usage: $0 [-u sql_user] [-p sql_password] [-a jdbc|mysql]"

#
# Command line arguments
#
# -a mysql	   	(default is mysql)              Method used to access DB
# -f                    (default is off)	       Will "force", destroying the cfengine database first

# Table names are set in config.sh
CF_PATH=`dirname $0`/..
export CF_PATH
. $CF_PATH/config.sh

DB=mysql

FORCE=""

# Process command line arguments
while getopts fha: opt
do
        case $opt in 
	a)	DB=$OPTARG;;
	f)	FORCE=1;;
        h|\?)     echo $Usage
                exit 1;
        esac
done

echo "This script:"; 
echo "     * will create the database and the necessary tables for the server"; 
echo "     * assumes that the SQL user specified in config.sh has been created";
echo

case $DB in
	mysql) 
		if [ "$FORCE" ]; then
			echo "Dropping existing tables"
			$CF_PATH/bin/mysql/drop_tables.sh

			# Initially had client db separate, but too much hassle for now
			$CF_PATH/bin/mysql/drop_client_tables.sh
		fi
		echo "Creating database and tables in MySQL"; echo
		$CF_PATH/bin/mysql/initialize_tables.sh

		# Initially had client db separate, but too much hassle for now
		$CF_PATH/bin/mysql/initialize_client_tables.sh
	;;
esac
