#!/bin/sh
####################################################################
# shell command for building the test database.
####################################################################

Usage="usage: $0 "

# Table names are set in config.sh
CF_PATH=`dirname $0`/../..
export CF_PATH
. $CF_PATH/config.sh


$MySqlBinDir/mysql --host=$SqlHost --user=$SqlUser --password=$SqlPassword  --local-infile <<EOF


####################################################
# mysql script for building the SQL test database  #
####################################################

CREATE DATABASE IF NOT EXISTS $TestDbName;

USE $TestDbName;

########################################################################
# Copy tables from DB to the Test DB
########################################################################

CREATE TABLE IF NOT EXISTS $RatingTable (
	UserID INT(10) DEFAULT 0 NOT NULL, 
	ItemID INT(10) DEFAULT 0 NOT NULL, 
	Rating DOUBLE DEFAULT 0 NOT NULL, 
	PRIMARY KEY (UserID, ItemID),
        INDEX (ItemID, UserID)
);

INSERT INTO $RatingTable SELECT * FROM $SqlDbName.$RatingTable;

CREATE TABLE IF NOT EXISTS $UserInfoTable (
	UID INT(10) PRIMARY KEY DEFAULT 0 NOT NULL AUTO_INCREMENT, 
	NumRatings INT(10) DEFAULT 0, 
	Utility FLOAT(10) , 
	INDEX(UID)
); 
INSERT INTO $UserInfoTable SELECT * FROM $SqlDbName.$UserInfoTable;

CREATE TABLE IF NOT EXISTS $ItemTypeTable (
	ItemID INT(10) DEFAULT 0 NOT NULL, 
	TypeID INT(10) DEFAULT 0 NOT NULL, 
	INDEX(TypeID)
);
INSERT INTO $ItemTypeTable SELECT * FROM $SqlDbName.$ItemTypeTable;

CREATE TABLE IF NOT EXISTS $IdTable (
	Id INT(10) DEFAULT 0 NOT NULL,
  	name VARCHAR(32) DEFAULT '' NOT NULL 
);
INSERT INTO $IdTable SELECT * FROM $SqlDbName.$IdTable;

quit

EOF
