#!/bin/sh

#############################################################
# shell command for building tables needed by the text
# client provided with the distribution. 
####################################################################

Usage="usage: $0 [-d database] [-u sql_user] [-p sql_password]"

#
# Command line arguments
#
# -d SQL_DB       (default set in config.sh)
# -u SQL_USER     (default set in config.sh)
# -p SQL_PASSWORD (default set in config.sh)

# Table names are set in config.sh
CF_PATH=`dirname $0`/../..
export CF_PATH
. $CF_PATH/config.sh

# Process command line arguments
while getopts hd:u:p: opt
do
        case $opt in 
        d)      SqlDbName=$OPTARG;;
	u)      SqlUser=$OPTARG;;
	p)      SqlPassword=$OPTARG;;
        h|\?)     echo $Usage
                exit 1;
        esac
done

$MySqlBinDir/mysql --user=$SqlUser --password=$SqlPassword --host=$SqlHost <<EOF

###############################################
# mysql script for dropping the SQL tables for the client  #
###############################################

USE $SqlDbName ;

############################################################################
# Drop Tables
############################################################################

DROP TABLE IF EXISTS $UserTable ;

DROP TABLE IF EXISTS $ItemTable ;

DROP TABLE IF EXISTS $TypeTable ;

quit

EOF
