#!/bin/sh

#############################################################
# shell command for building tables needed by the text
# client provided with the distribution. 
####################################################################

Usage="usage: $0 [-d database] [-u sql_user] [-p sql_password]"

#
# Command line arguments
#
# -d SQL_DB       (default set in config.sh)
# -u SQL_USER     (default set in config.sh)
# -p SQL_PASSWORD (default set in config.sh)

# Table names are set in config.sh
CF_PATH=`dirname $0`/../..
export CF_PATH
. $CF_PATH/config.sh

# Process command line arguments
while getopts hd:u:p: opt
do
        case $opt in 
        d)      SqlDbName=$OPTARG;;
	u)      SqlUser=$OPTARG;;
	p)      SqlPassword=$OPTARG;;
        h|\?)     echo $Usage
                exit 1;
        esac
done

$MySqlBinDir/mysql --user=$SqlUser --password=$SqlPassword --host=$SqlHost <<EOF

###############################################
# mysql script for creating the SQL tables for the client  #
###############################################

CREATE DATABASE IF NOT EXISTS $SqlDbName;

USE $SqlDbName

############################################################################
# Create Tables
############################################################################

CREATE TABLE IF NOT EXISTS $UserTable (
	UserID INT(10) PRIMARY KEY DEFAULT 0 NOT NULL AUTO_INCREMENT, 
	UserName VARCHAR(30),
	INDEX(UserName),
	INDEX(UserId)
);

CREATE TABLE IF NOT EXISTS $ItemTable (
	ItemID INT(10) PRIMARY KEY DEFAULT 0 NOT NULL AUTO_INCREMENT, 
	ItemName VARCHAR(100),
	INDEX(ItemName),
	INDEX(ItemId)
);

CREATE TABLE IF NOT EXISTS $TypeTable (
 	TypeID int(10) NOT NULL auto_increment,
  	TypeName varchar(100) default NULL,
  	PRIMARY KEY  (TypeID)
);

quit

EOF
