#!/bin/sh

####################################################################
# Drops the cfengine database
####################################################################


Usage="usage: $0 "

# Table names are set in config.sh
CF_PATH=`dirname $0`/../..
export CF_PATH
. $CF_PATH/config.sh

$MySqlBinDir/mysql --host=$SqlHost --user=$SqlUser --password=$SqlPassword --host=$SqlHost <<EOF

###############################################
# mysql script for building the SQL database  #
###############################################

CREATE DATABASE IF NOT EXISTS $SqlDbName;

USE $SqlDbName;

#######################################################################################
# Please specify the names of your user, item and rating tables in the following      #
# CREATE commands.                                                                    #
#######################################################################################

CREATE TABLE IF NOT EXISTS $RatingTable (
	UserID INT(10) DEFAULT 0 NOT NULL, 
	ItemID INT(10) DEFAULT 0 NOT NULL, 
	Rating DOUBLE DEFAULT 0 NOT NULL, 
	PRIMARY KEY (UserID, ItemID),
        INDEX (ItemID, UserID)
);

CREATE TABLE IF NOT EXISTS $UserInfoTable (
	UID INT(10) PRIMARY KEY DEFAULT 0 NOT NULL AUTO_INCREMENT, 
	NumRatings INT(10) DEFAULT 0, 
	Utility FLOAT(10) , 
	INDEX(UID)
# Index on utility doesn't seem to help with startup times, at least
# with 1000 users or less. 
#	INDEX(Utility)
); 

CREATE TABLE IF NOT EXISTS $ItemTypeTable (
	ItemID INT(10) DEFAULT 0 NOT NULL, 
	TypeID INT(10) DEFAULT 0 NOT NULL, 
	INDEX(TypeID)
);

CREATE TABLE IF NOT EXISTS $IdTable (
	Id INT(10) DEFAULT 0 NOT NULL,
  	name VARCHAR(32) DEFAULT '' NOT NULL 
);

quit

EOF
