#!/bin/csh
#
# This script is simply a wrapper around cfengine_nightly_build.sh
# that redirects I/O and removes log files if there are no errors
#
# You need to add the following line to your crontab to do a 
# build every night at 2AM. (without the '#')
#0 2 * * * /nfs/ca/info/www_cs/iis/cfengine_nightly/bin/nightly.csh 

set dir=/nfs/ca/info/www_cs/iis/cfengine_nightly

set NightlyBin=$dir/bin/cfengine_nightly_build.sh
set LogFile=$dir/nightly.log

cd $dir

# The follow I/O redirect will send stdin, stdou to the log file and 
# also overwrite the file if it already exists. 
${NightlyBin} >&! $LogFile
if ( $status != 0 ) then 
	mailx -s "cfengine nightly build failed" collab@cs.orst.edu < $LogFile
endif
