/* 
 * ClientCppSession.h
 * 
 * Version 1.1
 * 
 * 28/10/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */


/**
 * The client session
 * Implement
 * 1. Rate an item.
 * 2. Get rating for an item.
 * 3. Get top n recommendation.
 * 4. Get top n recommendation of specific type.
 * 5. Get predicted rating for an item.
 *
 * @author  Yun Wang
 */
 
namespace org{

namespace recommender{

namespace clients{

class ClientCppSession {

public:
     ClientCppSession();
     virtual ~ClientCppSession();
     
     
	 ClientCppSession(org::recommender::server::corba::CFEngineCorba* p);
     
     virtual void endSession();
     
     virtual void startSession();
     
     virtual void getUserInput();
     
     virtual void setRating();
     
     virtual void getRating();
     
     virtual void getRecommendations();

	 virtual void getRecommendationsByType();
     
     virtual void getPredictedRating();

private:

	org::recommender::server::corba::CFEngineCorba* engine;
     int userId;


   };  // End of class ClientCppSession

} // End of namespace clients

} // End of namespace recommender

} // End of namespace org

