/* 
 * CFEngineClientCpp.cpp
 * 
 * Version 1.1
 * 
 * 16/10/2002
 *
 * Copyright (c) 2002 Oregon State Universtity. All rights reserved.
 */

#include <CFEngineCorbaC.h>
#include <ClientCppSession.h>
#include <iostream.h>
#include <iomanip.h>
#include <CFEngineClientCpp.h>


/**
 * The CF Engine client - using Corba. A small online interface
 * that can be used to test the CFEngine recommender server.
 *
 * @author  Yun Wang
 */
CFEngineClientCpp::CFEngineClientCpp()
{

   cout << "This is the original Corba Cpp Client\n";
}

CFEngineClientCpp::~CFEngineClientCpp()
{
}




int CFEngineClientCpp::cppMain()
{
    int status = EXIT_SUCCESS;
    CORBA::ORB_var orb;
    int argc = 3;
    char *argv[]= {"try", "linux", "perl"};


    try
    {
	   orb = CORBA::ORB_init(argc, argv);
	   
	  const char* refFile = "../../../../cfengine.ref";
      ifstream in(refFile);
      char s[2048];
      in >> s; 
    
      int status=0;
   
   // Register valuetype factories	
  /*  CORBA::ValueFactoryBase_var factory = 
              new edu::orst::recommender::server::ItemPredictionCorbaFactory();
   ((CORBA::ORB_var)orb)->register_value_factory(
       "IDL:edu/orst/recommender/server/ItemPredictionCorba:1.0", factory);
   //    (CORBA::ValueFactoryBase)new edu::orst::recommender::server::ItemPredictionCorbaFactory());
  */     
       
     CORBA::Object_var obj = orb -> string_to_object(s);
    if (CORBA::is_nil(obj)) {
      cout << "Found object from orb" << endl;
      return EXIT_FAILURE;
      }
     
      cout  << s <<endl;
          
     org::recommender::server::corba::CFEngineCorba_var engine =
                 org::recommender::server::corba::CFEngineCorba::_narrow(obj);
      assert(!CORBA::is_nil(engine));
   
      cout << engine->test() << endl; 
      
    //
    //  do user session
    //
    
      org::recommender::clients::ClientCppSession *client =
        new org::recommender::clients::ClientCppSession(engine);
    client->startSession();
	   
	   
    } catch (const CORBA::Exception& ex) {
//	    cerr << ex << endl;
	    status = EXIT_FAILURE;
    }
    cout << status <<endl;
 
    try
	{
	    orb -> destroy();
	}
    catch (const CORBA::Exception& ex)
	{
	  //  cerr << ex << endl;
	    status = EXIT_FAILURE;
	}   
    
    return status;
}
    