/*
 * ItemRating.java
 * 
 * Version 1.0
 *
 * 01/05/2004
 * 
 * Copyright (c) 2004 Federal Universtity of Pernambuco. All rights reserved.
 */
package feers.recommender.algorithms.symbolic;

import java.io.Serializable;

import org.recommender.server.ItemRating;


public class ItemRatingComparable extends ItemRating implements Serializable, Comparable {
	private boolean p;
	
	public ItemRatingComparable(int user, int item, float g, boolean estimated) {
		super(user, item, g);
		p = estimated;
	}
	
	public int hashCode() {
		return super.getItemID();
	}
	public int compareTo(Object o) {
		int res = 1;
		if (o != null && o instanceof ItemRatingComparable) {
			ItemRatingComparable other = (ItemRatingComparable) o;
			if (getItemID() < other.getItemID()) {
				res = -1;
			} else if (getItemID() == other.getItemID()) {
				res = 0;
			}
		}
		return res;
	}
	public boolean equals(Object o) {
		boolean res = false;
		if (o != null && o instanceof ItemRatingComparable) {
			ItemRatingComparable other = (ItemRatingComparable) o;
			if (getItemID() == other.getItemID()) {
				res = true;
			}
		}
		return res;
	}
	
	/**
	 * @return
	 */
	public boolean isEstimated() {
		return p;
	}

}