/*
 * KnnContentBasedAlgorithm.java
 * 
 * Version 1.0
 *
 * 01/05/2004
 * 
 * Copyright (c) 2004 Federal Universtity of Pernambuco. All rights reserved.
 */
package feers.recommender.algorithms.symbolic;

import java.sql.SQLException;

import org.recommender.algorithms.CFAlgorithm;
import org.recommender.algorithms.CFNotImplementedException;
import org.recommender.server.DataManager;
import org.recommender.server.ItemPrediction;
import org.recommender.server.Stats;

import feers.recommender.server.DataItemManager;

/**
 * Describes an implementation of the CFAlgorithm interface
 * to make ContentBased predictions using the kNN approach
 * where each item evaluated by user is an example.
 * 
 * @author <a href="mailto:bldb@cin.ufpe.br>Byron L. D. Bezerra</a>
 */
public class KnnContentBasedAlgorithm implements CFAlgorithm {

	/**
	 * Database tools for this algorithm
	 */
	private DataManager dataMgr;
	private DataItemManager dataItemMgr;

	///////// Parameters /////////////////

	  private long Time = 0;
	  private long NumPredictions = 0;
	  private Stats timeStats = new Stats();
	  
	  public KnnContentBasedAlgorithm(DataManager dataMgr) {
		  this(dataMgr, new DataItemManager(0, dataMgr.getMaxItem()));
	  }

	  public KnnContentBasedAlgorithm(
		  DataManager dataMgr,
		  DataItemManager dataItemMgr) {
		  this.dataMgr = dataMgr;
		  this.dataItemMgr = dataItemMgr;
		  
		  // Get parameters
		  String prefix = "CFServer.alg.knncontent.";
		
//		  USE_REPLICATION_OR_WEIGHT =
//			  SystemProperties.getBoolean(prefix + "useReplication", false);

		  if (dataMgr.getMaxRating() <= 1.0)
			  throw new RuntimeException("This algorithm is not prepared to work with grades beetwen 0 and 1.");

		  // create the subprofiles keys
		  // supondo que as notas sao entre 1 e 5
//		  if (USE_REPLICATION_OR_WEIGHT == false) {
//			  int numberOfClasses =
//				  (int) (this.dataMgr.getMaxRating()
//					  - this.dataMgr.getMinRating()
//					  + 1);
//			  relevances = new ModalSymbolicObjectRelevance[numberOfClasses];
//			  relevances[0] = new ModalSymbolicObjectRelevance(3, -1, 0);
//			  relevances[1] = new ModalSymbolicObjectRelevance(2, -1, 1);
//			  relevances[2] = new ModalSymbolicObjectRelevance(1, 1, 2);
//			  relevances[3] = new ModalSymbolicObjectRelevance(2, 1, 3);
//			  relevances[4] = new ModalSymbolicObjectRelevance(3, 1, 4);
//		  } else {
//			  relevances = new ModalSymbolicObjectRelevance[2];
//			  relevances[0] = new ModalSymbolicObjectRelevance(1, 1, 0);
//			  relevances[1] = new ModalSymbolicObjectRelevance(1, -1, 1);
//		  }
	  }

	/* (non-Javadoc)
	 * @see org.recommender.algorithms.CFAlgorithm#predictRating(int, int)
	 */
	public ItemPrediction predictRating(int userID, int itemID)
		throws CFNotImplementedException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.recommender.algorithms.CFAlgorithm#getRecommendations(int, int)
	 */
	public ItemPrediction[] getRecommendations(int activeUser, int n)
		throws SQLException, CFNotImplementedException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.recommender.algorithms.CFAlgorithm#getAveragePredictionTime()
	 */
	public long getAveragePredictionTime() throws CFNotImplementedException {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see org.recommender.algorithms.CFAlgorithm#updateUser(int)
	 */
	public void updateUser(int userID) throws CFNotImplementedException {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.recommender.algorithms.CFAlgorithm#getRecommendationsByType(int, int, int)
	 */
	public ItemPrediction[] getRecommendationsByType(
		int activeUser,
		int n,
		int type)
		throws SQLException, CFNotImplementedException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.recommender.algorithms.CFAlgorithm#getTimeStats()
	 */
	public Stats getTimeStats() {
		// TODO Auto-generated method stub
		return null;
	}

}
