/*
 * PairValueWeight.java
 * 
 * Version 1.0
 *
 * 07/04/2004
 * 
 * Copyright (c) 2004 Federal Universtity of Pernambuco. All rights reserved.
 */
package feers.recommender.algorithms.symbolic;

import java.io.Serializable;


public class PairValueWeight implements Serializable, Comparable {
	private String value;
	private double weight;
	public PairValueWeight(Object v, double w) {
		this.value = v.toString();
		this.weight = w;
	}
	public int hashCode() {
		return this.value.hashCode();
	}
	public boolean equals(Object other) {
		boolean r = false;
		if (other instanceof PairValueWeight) {
			r = ((PairValueWeight) other).value.equals(this.value);
		}
		return r;
	}

	public int compareTo(Object other) {
		int r = -1;
		if (other instanceof PairValueWeight) {
			PairValueWeight p = (PairValueWeight) other;
			r=this.value.compareTo(p.value);
		}
		return r; 
	}

	/**
	 * @return
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param value
	 */
	public void setValue(String value) {
		this.value = value;
	}

	/**
	 * @return
	 */
	public double getWeight() {
		return weight;
	}

	/**
	 * @param weight
	 */
	public void setWeight(double weight) {
		this.weight = weight;
	}

}