/*
 * CathegoricalMultivaluedDescriptor.java
 * 
 * Version 1.0
 *
 * 28/03/2004
 * 
 * Copyright (c) 2004 Federal Universtity of Pernambuco. All rights reserved.
 */
package feers.recommender.server.descriptor;

import java.util.Iterator;
import java.util.List;

/**
 * Represents a cathegorical multivalued variable.
 * 
 * @author <a href="mailto:bldb@cin.ufpe.br>Byron L. D. Bezerra</a>
 */
public class CathegoricalMultivaluedDescriptor extends Descriptor {

	private List values;
	
	/**
	 * @param name
	 */
	public CathegoricalMultivaluedDescriptor(String name, List values) {
		super(name);
		if (values != null && values.size() > 0)
			this.values = values;
		else
			throw new IllegalArgumentException(
				"The list of values in " + this.getName() + " cannot be empty.");
	}

	/**
	 * Returns the value of this cathegorical multivalued variable in a 
	 * List object. Each object in the returned List is a String.
	 * 
	 * @see feers.recommender.server.Descriptor#getValue()
	 * @return Object
	 */
	public Object getValue() {
		return values;
	}

	public String toString() {
		StringBuffer res = new StringBuffer(super.toString());
		for (Iterator iter = values.iterator(); iter.hasNext();) {
			String element = (String) iter.next();
			res.append(element);
			if (iter.hasNext())
				res.append(", ");
		} 
		return  res.toString();
	}
}
