/*
 * CathegoricalUnivaluedDescriptor.java
 * 
 * Version 1.0
 *
 * 28/03/2004
 * 
 * Copyright (c) 2004 Federal Universtity of Pernambuco. All rights reserved.
 */
package feers.recommender.server.descriptor;

/**
 * Represents a cathegorical univalued variable.
 * 
 * @author <a href="mailto:bldb@cin.ufpe.br>Byron L. D. Bezerra</a>
 */
public class CathegoricalUnivaluedDescriptor extends Descriptor {

	private String value;

	/**
	 * @param name
	 * @param value
	 */
	public CathegoricalUnivaluedDescriptor(String name, String value) {
		super(name);
		if (value != null && value.trim().length() > 0)
			this.value = value.trim();
		else
			throw new IllegalArgumentException(
				"The value in " + this.getName() + " cannot be empty.");
	}

	/**
	 * Returns the value of this cathegorical univalued variable in a String object.
	 * 
	 * @see feers.recommender.server.Descriptor#getValue()
	 * @return Object
	 */
	public Object getValue() {
		return this.value;
	}

	public String toString() {
		return super.toString() + this.value;
	}

}
