/*
 * NumericDescriptor.java
 * 
 * Version 1.0
 *
 * 28/03/2004
 * 
 * Copyright (c) 2004 Federal Universtity of Pernambuco. All rights reserved.
 */
package feers.recommender.server.descriptor;

/**
 * This class represents a numeric discrete variable. 
 * 
 * @author <a href="mailto:bldb@cin.ufpe.br>Byron L. D. Bezerra</a>
 */
public class NumericDescriptor extends Descriptor {

	private int value;
	
	/**
	 * @param name
	 * @param value
	 */
	public NumericDescriptor(String name, int value) {
		super(name);
		this.value = value;
	}

	/** 
	 * Returns the value of this numeric variable in a Integer object.
	 * 
	 * @see feers.recommender.server.Descriptor#getValue()
	 * @return Object
	 */
	public Object getValue() {
		return new Integer(value);
	}
	
	public String toString() {
		return super.toString() + this.value;
	}

}
