/* 
 * CompPrediction.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
package org.recommender.algorithms;

import org.recommender.server.*;
import java.io.*;
import java.util.*;

/**
 * Implements the Comparator interface to efficiently sort arrays of ItemPrediction.
 *
 * @author Olivier Godde
 */
public class CompPrediction implements Comparator {

	DataManager dataMgr;
    /**
     * Constructor.
     */
	public CompPrediction(DataManager dm){
		dataMgr= dm;
	}
	
	/**
	 * Constructor, with two objects.
	 * @param object1
	 * @param object2
	 * @return 1, -1, or 0
	 */
	public int compare(Object e1, Object e2){
	
		ItemPrediction r1= (ItemPrediction) e1;
		ItemPrediction r2= (ItemPrediction) e2;
		
		float pvalue1;
		float pvalue2;
		//System.out.println("rating is = " + r1.getRating());
		try{
			pvalue1= r1.getPrediction();
		} catch (Exception ex){
		 	pvalue1= dataMgr.getMinRating();
		}
		try{
			pvalue2= r2.getPrediction();
		} catch (Exception ex){
		 	pvalue2= dataMgr.getMinRating();
		}
			
		if (pvalue1 < pvalue2)
			return 1;
		else
			if (pvalue1 > pvalue2)
				return -1;
			else
				return 0;	
	}
}
