/* 
 * CorrelationCoeff.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
 
package org.recommender.algorithms;

import org.recommender.server.*;
/**
 * Simple struct to hold coeff value along with userID.
 *
 * @author  <A HREF="mailto:iyoon@cs.orst.edu">Irwin Yoon</A>
 * @author  <A HREF="mailto:dlowd@cs.orst.edu">Daniel Lowd</A>
 * 
 */
public class CorrelationCoeff implements Comparable{

    // members
    private int userID;
    private float coeff;
	
    /**
     * Constructors with both userID and coeff are known.
     * @param userID
     * @param val
     */    
    public CorrelationCoeff(int userID, float val) {
        this.userID = userID;
        coeff = val;
        
    }   

    /**
     * Accessor, return userID.
     * @return userID
     */
    public int getUserID() {
        return userID;
    }

    /**
     * Accessor, return coefficient.
     * @return coeff
     */
    public float getCoeff() {
        return coeff;
    }   
    
    /**
     * Implemented to satisfy Comparable.  Allows for CorrelationCoeff
     * to be sorted according to ones coeff score
     */
    public int compareTo(Object o) {

        CorrelationCoeff coeff1 = (CorrelationCoeff) o;
        if (coeff1.getCoeff() == coeff)
            return 0;
        else if (coeff1.getCoeff() > coeff)
            return -1;
        else
            return 1;
    }
}
