/* 
 * Comp.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
package org.recommender.algorithms.Experimental;

import org.recommender.server.*;
import java.io.*;
import java.util.*;

/**
 * Implements the Comparator interface to efficiently sort arrays.
 *
 * @author Olivier Godde
 */
public class Comp implements Comparator {

    /**
     * Constructor, does nothing.
     */
	public Comp(){
	
	}
	
	/**
	 * Constructor, with two objects.
	 * @param object1
	 * @param object2
	 * @return 1, -1, or 0
	 */
	public int compare(Object e1, Object e2){
	
		ItemRating r1= (ItemRating) e1;
		ItemRating r2= (ItemRating) e2;
		
		float rvalue1;
		float rvalue2;
		//System.out.println("rating is = " + r1.getRating());
		try{
			rvalue1= r1.getRating();
		} catch (Exception ex){
		 	rvalue1= 0;
		}
		try{
			rvalue2= r2.getRating();
		} catch (Exception ex){
		 	rvalue2= 0;
		}
			
		if (rvalue1 < rvalue2)
			return 1;
		else
			if (rvalue1 > rvalue2)
				return -1;
			else
				return 0;	
	}
}
