/* 
 * Experiment.java
 * 
 * Version 1.1
 * 
 * 16/02/2003
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */ 


package org.recommender.algorithms.Experimental.DataBank;


/**
 * Class object matching with the Experiment table in the DataBank data base.
 * 
 * @author  <A HREF="mailto:nong@cs.orst.edu">Shuzhen Nong</A>
 *
 */


public class Experiment implements java.io.Serializable
{

    
    protected float MAE;
   
    protected float Coverage;
    
    protected String algName;
    
    protected String ExperimentTime;
    
   
    private int ExperimentId;
    
    
    public Experiment(int ExperimentId, String ExperimentTime, String algName, float MAE, float Coverage)
    {
        this.ExperimentId = ExperimentId;
        this.ExperimentTime = ExperimentTime;
        this.algName = algName;
        this.MAE = MAE;
        this.Coverage = Coverage;
    } 
      

    /**
     * Return the primary id 
     *
     * @return int
     */
    public int getId()
    {
        return ExperimentId;
    }

    /**
     * Return algorithm's name
     *
     * @return java.lang.String
     */
    public java.lang.String getName()
    {
        return algName;
    }

    /**
     * Return MAE ( Mean Average Error )
     *
     * @return float
     */
    public float getMAE()
    {
        return MAE;
    }

    /**
     * Return Coverage.
     *
     * @return int
     */
    public float getCoverage()
    {
        return Coverage;
    }

    /**
     * Set Experiment id
     * @param new_id int
     */
    public void setId(int new_id)
    {
        ExperimentId = new_id;
    }

    /**
     * Set algorithm name
     *
     * @param newName java.lang.String
     */
    public void setName(java.lang.String newName)
    {
        algName = newName;
    }

    /**
     * Set MAE
     * 
     * @param newMAE float
     */
    public void setMAE(float newMAE)
    {
        MAE = newMAE;
    }

    /**
     * Set new Coverage
     *
     * @param newCoverage float
     */
    public void setCoverage(float newCoverage)
    {
        Coverage = newCoverage;
    }

    /**
     * Return experiment information: id, name, MAE, and Coverage
     *
     * @return String
     */
    public String toString()
    {
        return "[" + ExperimentId + "] " + algName + "\t\t\t MAE: " + MAE + "\t\t Coverage: " + Coverage;
    }
}
