/* 
 * Multinomial.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */ 

package org.recommender.algorithms.Experimental;

import org.recommender.server.*;
import java.util.*;

/**
 * Represents a tag for a multinomial probability distribution, and 
 * its contents. 
 *
 * @@author Daniel Lowd <dlowd@@cs.orst.edu>
 */
public class Multinomial
{
    ArrayList probs;

    /** 
     * Construct an empty multinomial.
     */
    public Multinomial()
    {
        probs = new ArrayList();
    }

    /** 
     * Add a Probs tag to this multinomial.
     * @@param pcdata Probs tag contents
     */
    public void addProbs(String pcdata)
    {
        int index = 0;
        StringTokenizer st = new StringTokenizer(pcdata);
        while (st.hasMoreTokens())
        {
            String probVal = st.nextToken();
            probs.add(index, new Float(probVal));
            index++;
        }
    }

    /**
     * Return the float value of Probs.
     * @@param state
     * @@return prob
     */
    public float getProb(int state)
    {
        Float prob = (Float)probs.get(state);
        return prob.floatValue();
    }
}
