/* 
 * ItemRatingPair.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
 
package org.recommender.algorithms;

import org.recommender.server.*;
/**
 * Contains Ratings for the same movie for
 * 1) the active user and 2) the neighbor.
 *
 * @author  <A HREF="mailto:iyoon@cs.orst.edu">Irwin Yoon</A>
 * 
 */
public class ItemRatingPair {
   
    private ItemRating activeUser;
    private ItemRating neighbor;

    /**
     * Constructor with both activeUser and neighbor are availble.
     * @param activeuser
     * @param neighbor
     */
    public ItemRatingPair(ItemRating activeuser, ItemRating neighbor) {
        this.activeUser = activeuser;
        this.neighbor = neighbor;
    }

    /**
     * Accessor, return activeUser
     * @return activeUser
     */
    public ItemRating getActiveUserRating() {
        return activeUser;
    }

    /**
     * Accessor, return neighbor(rating).
     * @return neighbor
     */
    public ItemRating getNeighborRating() {
        return neighbor;
    }
}
