/* 
 * CFEngineClientCpp.cpp
 * 
 * Version 1.1
 * 
 * 16/10/2002
 *
 * Copyright (c) 2002 Oregon State Universtity. All rights reserved.
 */
 
#include <CFEngineCorbaC.h>
#include <ClientCppSession.h>
#include <iostream.h>
#include <iomanip.h>

/**
 * The CF Engine client - using Corba. A small online interface
 * that can be used to test the CFEngine recommender server.
 *
 * @author  Yun Wang
 */

int
run(CORBA::ORB_ptr orb, int argc, char* argv[])
{
    
    const char* refFile = "../../../../cfengine.ref";
    ifstream in(refFile);
    char s[2048];
    in >> s; 
    
    int status;
   
   CORBA::Object_var obj = orb -> string_to_object(s);
    if (CORBA::is_nil(obj)) {
      cout << "Found object from orb" << endl;
      return EXIT_FAILURE;
     }
     
    cout  << s <<endl;
    
	org::recommender::server::corba::CFEngineCorba_var engine =
		org::recommender::server::corba::CFEngineCorba::_narrow(obj);
    assert(!CORBA::is_nil(engine));
   
   // cout << engine->test() << endl; 
      
    //
    //  do user session
    //
    
    org::recommender::clients::ClientCppSession *client =
        new org::recommender::clients::ClientCppSession(engine);
    client->startSession();
    
    return EXIT_SUCCESS;
   
}


int
main(int argc, char* argv[], char*[])
{
    int status = EXIT_SUCCESS;
    CORBA::ORB_var orb;

    try
    {
	   orb = CORBA::ORB_init(argc, argv);
	
	   status = run(orb, argc, argv);
	   
	   
    } catch (const CORBA::Exception& ex) {
//	    cerr << ex << endl;
	    status = EXIT_FAILURE;
    }
    cout << status <<endl;
 
    try
	{
	    orb -> destroy();
	}
    catch (const CORBA::Exception& ex)
	{
	  //  cerr << ex << endl;
	    status = EXIT_FAILURE;
	}   
    
    return status;
}
    