/*
 * SystemConstants.java
 *
 * Version 1.1
 *
 * 15/08/2002
 *
 * Copyright (c) 2002 Oregon State Universtity. All rights reserved.
 */

package org.recommender.clients.console;

/**
 * A central place for user, item data and client API constants.
 *
 * @author Irwin Yoon
 * @author Daniel Lowd
 */
public class ClientConstants {

    /**
     * Added by Yun Wang
     * Name of type table
     */
    public static final String TYPE_TABLE = "TYPE_TABLE";

    /**
     * Name of usertable
     */
    public static final String USER_TABLE = "USER_TABLE";

    /**
     * Name of itemtable
     */
    public static final String ITEM_TABLE = "ITEM_TABLE";

    /**
     * Field of usertable - user id
     */
    public static final String USER_TABLE_FIELD_ID = "UserID";

    /**
     * Field of usertable - user name
     */
    public static final String USER_TABLE_FIELD_NAME = "UserName";

    /**
     * Field of itemtable - item id
     */
   	public static final String ITEM_TABLE_FIELD_ID = "ItemID";

   	/**
   	 * Field of itemtable - item name
   	 */
    public static final String ITEM_TABLE_FIELD_NAME = "ItemName";


    /**
     * Field of type table - type id
     */
    public static final String TYPE_TABLE_FIELD_ID = "TypeID";

     /**
     * Field of type table - type NAME
     */
    public static final String TYPE_TABLE_FIELD_NAME = "TypeName";

    //Seed ratings means those ratings which are needed for computing
    //predictions for a new user before she/he enters other ratings.

    /**
     * When you create an Item or a User object using a server-side id
     * but don't specify a Username, this name will be used.
     */
    public static final String NAME_UNAVAILABLE_STRING = "<<No Client-Side Name>>";

    public static final String DATABASE_PROP_FILE = "MySQL.properties";

}
