/*
* Exit.java
*
* Version 1.1
*
* 28/08/2002
*
* Copyright (c) 2002 Oregon State Universtity. All rights reserved.
 */

package org.recommender.clients.console;

import java.rmi.*;

import org.recommender.server.*;


/**
 * Simple client, calling the server's shutdown method.
 * @author  <A HREF="mailto:godde@cs.orst.edu">Olivier Godde</A>
 */

public class Exit{
    private static CFEngine engine = null;

    public static void main(String[] args){

        System.setSecurityManager(new RMISecurityManager());
        // Load properties
        String installdir = System.getProperty("cf.path",".");
        SystemProperties.loadProperties(installdir + "/lib/client.properties");

        //String url = "rmi://" + SystemConstants.RMI_NAMESERVER_MACHINE + "/";
        String url = "rmi://" + SystemProperties.getString("CFClient.rmi.nameserver") + "/";
		String bindName =SystemProperties.getString("CFClient.rmi.objectname"); 
        
        // Lookup the CF Engine server
        try {
           // engine = (CFEngine)Naming.lookup(url + "cfengine");
           engine = (CFEngine)Naming.lookup(url + bindName);
        } catch (Exception e) {
            System.out.println("Error: Cannot locate server on "
                               //+ SystemConstants.RMI_NAMESERVER_MACHINE);
                               + SystemProperties.getString("CFClient.rmi.nameserver"));
            System.out.println("Error: " + e);
            System.exit(1);
        }
        try{
            engine.shutdown();
        } catch(java.rmi.RemoteException ex){
            //System.out.println("WARNING: Exit: Cannot shut down server...");
            //ex.printStackTrace(System.out);
        }
    }


}
