/*
* Item.java
*
* Version 1.1
*
* 15/08/2002
*
* Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
package org.recommender.clients.console;

import java.io.*;

/**
 * Describes the Movie info for the CF Engine.
 *
 * @author  <A HREF="mailto:nong@cs.orst.edu">Shuzhen Nong</A>
 *
 */
public class Item implements Serializable {

    // Data Members
    private int itemID;
    private String itemName;

    /**
     * Constructor
     * @param id
     * @param name
     */
    public Item(int id, String name) {
        itemID = id;
        itemName = name;
    }

    /**
     * Costructor, when only movieID is available.
     * @param id
     */
    public Item(int id) {
        itemID = id;
        itemName = ClientConstants.NAME_UNAVAILABLE_STRING;
    }

    /**
     * Accessors, return movieID.
     * @return movieID
     */
    public int getID() {
        return itemID;
    }

    /**
     * Accessor, return movieName.
     * @return movieName
     */
    public String getName() {
        return itemName;
    }

    public String toString() {
        return getName() + " (id=" + getID() + ")";
    }
}