package org.recommender.clients.console;

/**
 * A Type is a category of items. Types allow you to create clusters of related
 * items. For example, in movies, you can have types be genres, so that
 * movies of similar genres are grouped together. The primary purpose is to allow you to
 * get predictions by type. For example, you can get the top recommendations
 * among comedy movies.
 *
 * Created by
 * User: herlock
 * Date: Apr 16, 2003
 * Time: 9:06:46 AM
 */
public class Type {
    private int typeId;
    private String typeName;

    public Type(int typeId, String typeName) {
        this.typeId = typeId;
        this.typeName = typeName;
    }

    public int getTypeId() {
        return typeId;
    }

    public void setTypeId(int typeId) {
        this.typeId = typeId;
    }

    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    public String toString() {
        return typeName + " (id=" + typeId + ")";
    }
}
