package CFEngineServlet;

import org.recommender.server.*;

import javax.servlet.http.HttpServlet;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.rmi.Naming;
import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import javax.naming.*;
import java.util.*;
import javax.rmi.*;

/**
 * <p>Title: ChooseAlg.java</p>
 * <p>Description: This servlet performs the several methods of the remote
 *                 interface CFEngine of the session.
 *                 Four jsp page will use this same servlet.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author: Yun Wang
 * @version 1.0
 */

public class ChooseAlg extends HttpServlet {

  CFEngine engine;
  private static final String logoutLine
                       = "<UL><A HREF='/JSPCFEngine/Login.jsp' >Log Out</A></UL>";
  private static final String endLine = "<BR><H3>Get More Function:</H3>" + "<UL>" +
                           "<LI><A HREF='/JSPCFEngine/ChooseFunction.jsp'>Choose More</A>" +
                           "</BODY></HTML>";

  public ChooseAlg() {

  } //constructor

  public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {

      float rate = -1;
      ItemPrediction[] rateList;
      HttpSession session = request.getSession(true);

      String func = request.getParameter("function");
      engine = (CFEngine) session.getAttribute("engine");

      String user = (String) session.getAttribute("userId");
      int userId = Integer.parseInt(user);

      response.setContentType("text/html");
      PrintWriter out = response.getWriter();
      String title;

      if (func.equals("Prediction")) {           // get prediction
        session.setAttribute("function", "Prediction");

        if (request.getParameter("item") == null){
          gotoPage("/JSPCFEngine/notValid.jsp?name=",request, response);
        }

        int item = ServletUtilities.getIntParameter(request, "item");
        if (item <= 0) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=item" , request, response);
          return;
        }

        try {
          rate = doPrediction(userId, item);
        } catch (CFIllegalParameterException e) {
          session.setAttribute("errmsg", e.getMessage());
          gotoPage("/JSPCFEngine/notValid.jsp?name=e" , request, response);
          return;
        }
        title = "Getting Prediction!" ;
        out.println(ServletUtilities.headWithTitle(title) +
                 "<BODY BGCOLOR = \"#FDF5E6\">\n" + logoutLine +
                 "<H2 ALIGN = CENTER>" + title + "</H2>\n" + "</Center>");
        out.println("Item " + item + "'s rating for user " + user + " is " + rate + ".");

      } else if (func.equals("TopNByType")){             // get recommendation By Type

        String str = request.getParameter("offset1");
        int offset1 = 0;
        if (str != null)
            offset1=Integer.parseInt(str);

        session.setAttribute("function", "TopNByType");

        int type = ServletUtilities.getIntParameter(request, "type");

        if (request.getParameter("numR") == null){
           gotoPage("/JSPCFEngine/notValid.jsp?name=numR",request, response);
           return;
        }
        int n = ServletUtilities.getIntParameter(request, "numR");
        if (offset1 < 0 ) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=offset" , request, response);
          return;
        }
        if (n < 0 ) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=numR" , request, response);
          return;
        }
        if (type < 0 ) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=type" , request, response);
          return;
        }

        title = "Getting " + n + " ratings of Type " + type;
        rateList = null;
        try {
          rateList = doRecommendationByType(userId, n, offset1, type);
        } catch (CFIllegalParameterException e) {
          session.setAttribute("errmsg", e.getMessage());
          gotoPage("/JSPCFEngine/notValid.jsp?name=e", request, response);
          return;
        }
        out.println(ServletUtilities.headWithTitle(title) +
                     "<BODY BGCOLOR = \"#FDF5E6\">\n" + logoutLine +
                     "<H2 ALIGN = CENTER>" + title + "</H2></CENTER>\n");

        for (int i = 0; i < rateList.length; i++) {          // display TopN
          out.println(rateList[i].getItemID() + "    " +
                      rateList[i].getPrediction()+ "<BR>");
        }

      } else if (func.equals("setRating")) {          // add rating
         if (request.getParameter("itemR") == null ||
                  request.getParameter("rating") == null)
              gotoPage("/JSPCFEngine/notValid.jsp?name=",request, response);

        session.setAttribute("function", "setRating");

        int itemId = ServletUtilities.getIntParameter(request,"itemR");
        String s = request.getParameter("rating");
        float rates = Float.parseFloat(s);

        if (itemId < 0){
          gotoPage("/JSPCFEngine/notValid.jsp?name=item" , request, response);
          return;
        }
        if (rates < engine.getMinRating() || rates > engine.getMaxRating()) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=rating", request, response);
          return;
        }
        int k = -1;
        try {
          k = addRating(userId, itemId, rates);
        } catch (CFIllegalParameterException e) {
          session.setAttribute("errmsg", e.getMessage());
          gotoPage("/JSPCFEngine/notValid.jsp?name=e" + e, request, response);
          return;
        }

        if ( k > 0) {
          title = "Rating added";
          out.println(ServletUtilities.headWithTitle(title) +
                 "<BODY BGCOLOR = \"#FDF5E6\">\n" + logoutLine +
                 "<H2 ALIGN = CENTER>" + title + "</H2>\n" + "</Center>");
          out.println("Item " + itemId + "'s rating has been added successfully.");
        }
      } else if (func.equals("TopN")) {
        String str = request.getParameter("offset");
        if (str == null)
          str = (String) session.getAttribute("offset");

        int offset = Integer.parseInt(str);
        session.setAttribute("function", "TopN");

        if (request.getParameter("numR") == null){
          gotoPage("/JSPCFEngine/notValid.jsp?name=numR",request, response);
        }
        int n = ServletUtilities.getIntParameter(request, "numR");

        if (offset < 0 ) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=offset" , request, response);
          return;
        }

        if (n < 0) {
          gotoPage("/JSPCFEngine/notValid.jsp?name=numR" , request, response);
          return;
        }
        title = "Getting " + n + " ratings!";
        rateList = null;
        try {
          rateList = doRecommendation(userId, n, offset);
        } catch (CFIllegalParameterException e) {
          session.setAttribute("errmsg", e.getMessage());
          gotoPage("/JSPCFEngine/notValid.jsp?name=e" , request, response);
          return;
        }

        out.println(ServletUtilities.headWithTitle(title) +
                    "<BODY BGCOLOR = \"#FDF5E6\">\n" + logoutLine +
                    "<H2 ALIGN = CENTER>" + title + "</H2></CENTER>\n");

        for (int i = 0; i < rateList.length; i++) {          // display TopN
          out.println(rateList[i].getItemID() + "    " +
                     rateList[i].getPrediction()+ "<BR>");
        }
        // record the offset
        session.setAttribute("offset", "" + (offset + rateList.length));
        out.println("<UL><A HREF='/JSPCFEngine/RecommendationOffSet.jsp'>More Recommendations</A></UL>");

      }
        out.println(endLine);

  } // doGet()

  public void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
     doGet(request, response);

  } // doPost()

  /** doPrediction()
   *  Perform prediction of the interface CFEngine
   *  Please don't change!
   */
  private float doPrediction(int userId, int itemId)
      throws CFIllegalParameterException {

     // float rate = -1;
      ItemPrediction rate = null;
      if (itemId > 0) {
        synchronized(engine) {
           try{
              rate = engine.getPredictedRating(userId, itemId);
       //    } catch (CFIllegalParameterException e) {
           } catch (java.rmi.RemoteException e) {
               System.out.println("not valid prediction" + e);
           }
        }
     }
     return rate.getPrediction();
   } // doPrediction()

  /** doRecommendation()
   *  Perform Recommendation of the interface CFEngine
   *  Please don't change!
   */
   private ItemPrediction[] doRecommendation(int userId, int num, int offset)
       throws CFIllegalParameterException{

     ItemPrediction[] rList = null;

     if (num > 0) {
       synchronized(engine){
         try {
             rList = engine.getRecommendations(userId, num, offset);
      //     } catch (CFIllegalParameterException e) {
      //       System.out.println("It's an illegal parameter." + e);
          } catch (java.rmi.RemoteException e) {
               System.out.println("not valid Recommendation" + e);
           }
       }
    }
     return rList;
   } // doRecommendation()

   /** doRecommendationByType()
    *  Perform RecommendationByType of the interface CFEngine
    *  Please don't change!
    */
  private ItemPrediction[] doRecommendationByType(int userId, int num,
                                                  int offset, int type)
      throws CFIllegalParameterException{

    ItemPrediction[] rList = null;

     if (num > 0) {
       synchronized(engine){
         try {
             rList = engine.getRecommendationsByType(userId, num, offset, type);
        //   } catch (CFIllegalParameterException e) {
        //     System.out.println("It's an illegal parameter." + e);
          } catch (java.rmi.RemoteException e) {
               System.out.println("not valid Recommendation" + e);
           }
       }
    }
     return rList;

  }


   /** setRating()
    *  Perform Recommendation of the interface CFEngine
    *  Please don't change!
   */
   private int addRating(int userId, int itemId, float rating)
       throws CFIllegalParameterException{
     if (itemId > 0 && rating >= 1 && rating <= 5) {
       synchronized(engine) {
          try {
             engine.setRating(userId, itemId, rating);
      //     } catch (CFIllegalParameterException e) {
      //       System.out.println("It's an illegal parameter." + e);
           } catch (java.rmi.RemoteException e) {
             System.out.println("not valid prediction" + e);
          }
       }
       return 1;
     }
     return -1;
   } // setRating()

   private void gotoPage(String address, HttpServletRequest request,
                          HttpServletResponse response)
                    throws ServletException, IOException {
      RequestDispatcher dispatcher =
          getServletContext().getRequestDispatcher(address);
      dispatcher.forward(request, response);
  }
}
