package CFEngineServlet;

import org.recommender.server.*;
import javax.servlet.http.HttpServlet;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


import java.rmi.Naming;
import java.rmi.RemoteException;
import java.util.*;
import java.rmi.*;
import java.net.*;
import java.rmi.server.*;


/**
 * <p>Title: Login.java</p>
 * <p>Description: This servlet get the interface CFEngine from the remote
 *                 server by using RMI and set it as a session object.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Yun Wang
 * @version 1.0
 */

public class Login extends HttpServlet {

  private CFEngine engine;

  public Login() {
      initCFEngine();

  }  //constructor()

  public void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
    int userId = ServletUtilities.getIntParameter(request, "userId");
    String password = request.getParameter("password");

    /** We don't implement real login, If you implement it,
     *  you can implement here.
     */
    if (userId < 0) {
          gotoPage("/NotValidUser.jsp", request, response);
      }

   /* Once loged in,  set a session for the user
    */
   HttpSession session = request.getSession(true);

   if (request.getParameter("login") != null) {
     session.setAttribute("engine", engine);
     session.setAttribute("userId", ""+ userId);

     // set the offset to 0 for recommendation
     session.setAttribute("offset", ""+ 0);
     session.setAttribute("errmsg", "");

     gotoPage("/JSPCFEngine/ChooseFunction.jsp?userId="+ userId, request, response);
    }

  } // doPost()


  private void gotoPage(String address, HttpServletRequest request,
                        HttpServletResponse response)
                  throws ServletException, IOException {
    RequestDispatcher dispatcher =
        getServletContext().getRequestDispatcher(address);
    dispatcher.forward(request, response);
  }

  /** initCFEngine()
   *  This method find the object on the remote server.
   *  Please don't change!
   */
  private void initCFEngine() {

    System.setSecurityManager(new RMISecurityManager());

    String url = "rmi://" + System.getProperty("java.rmi.server.hostname",".")+"/";

    // Lookup the CF Engine server
   try {
        engine = (CFEngine)Naming.lookup(url + "cfengine");
        System.out.println("engine is found");

         //SystemUtils.printDebug(engine.test());
    } catch (Exception e) {
        System.out.println("Error: Cannot locate server on " +
                     System.getProperty("java.rmi.server.hostname","."));

        System.out.println("Error: " + e);
        System.exit(0);
     }

  }
}
