/*
 * CFIllegalParameterException.java
 *
 * Version 1.1
 *
 * 23/03/2003
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
package org.recommender.server;

import java.lang.Exception;

/**
 * Exception handling illegal list argument passed into CFEngineImpl and DataManager
 *
 * @author  <A HREF="mailto:mclaughm@cs.orst.edu">Matt McLaughlin</A>
 * @since   JDK 1.2
 *
 */

public class CFIllegalListParameterException extends CFIllegalParameterException {
    public int numSuccessfull;
    public CFIllegalParameterException exception;

    /**
     *
     * @param msg
     * @param numSuccessfull
     */
    public CFIllegalListParameterException(String msg, int numSuccessfull) {
        super(msg);
        this.numSuccessfull = numSuccessfull;
        exception = null;
    }

    /**
     *
     * @param msg
     * @param numSuccessfull
     * @param exception Exception thrown by an individual element
     */
    public CFIllegalListParameterException(String msg, int numSuccessfull, CFIllegalParameterException exception) {
        super(msg);
        this.numSuccessfull = numSuccessfull;
        this.exception = exception;
    }

    public int getNumSuccessfull() {
        return numSuccessfull;
    }
}

