/*
 * CFIntenalErrorException.java
 *
 * Version 1.1
 *
 * 23/03/2003
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
package org.recommender.server;


/**
 * Exception handling illegal list argument passed into CFEngineImpl and DataManager
 *
 * @author  <A HREF="mailto:mclaughm@cs.orst.edu">Matt McLaughlin</A>
 * @since   JDK 1.2
 *
 */

public class CFInternalErrorException extends CFException {
    public Exception exception;

    /**
     *
     * @param msg
     */
    public CFInternalErrorException(String msg) {
        super(msg);
        exception = null;
    }

    /**
     *
     * @param msg
     * @param exception Exception caught
     */
    public CFInternalErrorException(String msg, Exception exception) {
        super(msg);
        this.exception = exception;
    }
    
    public void printStackTrace() {
	super.printStackTrace();
        System.out.println("Nested exception trace is : "); 
	exception.printStackTrace();
    }
}
