/* 
 * CacheUpdate.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
 
 package org.recommender.server;
 
 import java.io.*;
 import java.sql.*;
 import java.util.*;
 import java.net.*;
 import org.recommender.util.*;
 
/**
 * This class starts a thread which can update the cache while the 
 * server is running.
 *
 * @author  <A HREF="mailto:godde@cs.orst.edu">Olivier Godde</A>
 */ 
 public class CacheUpdate extends Thread
	{

    private DataManager dataMgr;
    
    /**
     * Constructor
     */
    public CacheUpdate(DataManager dtMgr){

      dataMgr = dtMgr;
    }
    
    /**
     * An infinite loop,get blocked into this function (in the cache Vector monitor)	
 	 * until the cache limit exeeds	
     */
    public void run() 
    {
    
    	SystemUtils.printDebug("Starting CacheUpdate thread...");
 		while(true){  
 		
 		 	SystemUtils.printDebug("CacheUpdate: Entering Loop..."); 	
				
 		 	dataMgr.refreshCache(); // Get blocked into this function (in the cache monitor)	
 		 							// Until the cache limit exeeds	
 		 }		
    }
    

	/**
	 * Disable this thread for while (static reference allows an external class to put it to sleep)
	 * @param time
	 */
    public static void setIdle(long time) {
    	
    	try{
				sleep(time);
		} catch(InterruptedException ex){
				System.out.println("WARNING: CacheUpdate: Could't invoke sleep function");
				ex.printStackTrace(System.out);
		}
    }
}
  
