/* 
 * ItemPrediction.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State University. All rights reserved.
 */
package org.recommender.server;

import java.io.*;

/**
 * Describes the Prediction info for the CF Engine - userID, itemID, and predicted rating.
 *
 * @author  <A HREF="mailto:ogodde@cs.orst.edu">Olivier Godde</A>
 * 
 */
public class ItemPrediction implements Serializable{

    // data members
    private int userID;
    private int itemID;
    private float prediction;

   /**
     * Constructor.
     * @param userID
     * @param itemID
     * @param pred
     */
    public ItemPrediction(int userID, int itemID, float pred) {
        this.userID = userID;
        this.itemID = itemID;
        this.prediction = pred;
    }

    /**
     * Accessor, return userID.
     * @return userID
     */
    public int getUserID() {
        return userID;
    }

    /**
     * Accessor, return itemID.
     * @return itemID
     */
    public int getItemID() {
        return itemID;
    }
    
    /**
     * Accessor, return prediction value.
     * @return rating
     */
    public float getPrediction() {
        return prediction;
    }
}
