/* 
 * ItemRating.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State University. All rights reserved.
 */
package org.recommender.server;

import java.io.*;

/**
 * Describes the Rating info for the CF Engine - userID, itemID, and rating.
 *
 * @author  <A HREF="mailto:iyoon@cs.orst.edu">Irwin Yoon</A>
 * 
 */
public class ItemRating
         implements Serializable {

    // data members
    private int userID;
    private int itemID;
    private float rating;

    
    /**
     * Constructor.
     * @param userID
     * @param itemID
     * @param rating
     */
    public ItemRating(int userID, int itemID, float rating) {
        this.userID = userID;
        this.itemID = itemID;
        this.rating = rating;
    }

    /**
     * Accessor, return userID.
     * @return userID
     */
    public int getUserID() {
        return userID;
    }

    /**
     * Accessor, return itemID.
     * @return itemID
     */
    public int getItemID() {
        return itemID;
    }
    
    /**
     * Accessor, return rating.
     * @return rating
     */
    public float getRating() {
        return rating;
    }
}
