/* 
 * Resample.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
 
 package org.recommender.server;
 
 import java.io.*;
 import java.sql.*;
 import java.util.*;
 import java.net.*;
// import org.recommender.shared.*;
 
/**
 * This class provides methods to start a thread which is responsible 
 * for re-sampling users.
 * 
 * @author  <A HREF="mailto:godde@cs.orst.edu">Olivier Godde</A>
 */ 
 public class Resample extends Thread
	{

    private int maxUsers = 0;
    private int maxItems = 0;

    private DataManager dataMgr;
    
    /**
     * Constructor
     */
    public Resample(DataManager dtMgr){

      dataMgr = dtMgr;
    }
    
    /**
     * An infinite loop
     */
    public void run() 
    {
    
 		while(true){
 		 	try{
                // 24 hours
				sleep(86400000);
//				sleep(10000);
			} catch(InterruptedException ex){
				System.out.println("WARNING: Resample: Could't invoke sleep function");
				ex.printStackTrace(System.out);
			}	
			
			SystemUtils.printDebug("Starting re-sampling");
			
 		 	dataMgr.sampleUsers(); 
 		 }
    }
    

	/**
	 * Disable this thread for while (static reference allows an external class to put it to sleep)
	 * @param time
	 */
    public static void setIdle(long time) {
    	
    	try{
				sleep(time);
		} catch(InterruptedException ex){
				System.out.println("WARNING: CacheUpdate: Could't invoke sleep function");
				ex.printStackTrace(System.out);
		}
    }
}
  