/* 
 * SynIntHashMap.java
 * 
 * Version 1.1
 * 
 * 30/05/2003
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */
 
package org.recommender.server;

import java.util.*;


/**
 Implement the synchronized IntHashMap.
 Synchronized on methods used in both ratingsMatrix and itemIndex:
 get(), put(), size(), iterator(), containsKey(), remove().
 
 @author  <A HREF="mailto:nong@cs.orst.edu">Shuzhen Nong</A>
 */

public class SynIntHashMap
{
    private IntHashMap map;
    
    public SynIntHashMap(IntHashMap map)
    {
       this.map = map;
    }
    
    public synchronized Object get( int key )
    {
       return  map.get(key);
    }
    
    public synchronized Object put( int key, Object value ) 
    {
        return map.put(key, value);
    }
    
    public synchronized int size()
	{
	     return map.size();
	}
	
	public synchronized Iterator iterator()
	{
	    return map.iterator();
	}
	
	public synchronized boolean containsKey( int key )
	{
	    return map.containsKey(key);
	}
	
	public synchronized Object remove( int key )
	{
	    return map.remove(key);
	}
}	
	
	    
	
	        
    
            