/* 
 * SystemUtils.java
 * 
 * Version 1.1
 * 
 * 15/08/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */ 
package org.recommender.server;

import java.text.*;
import java.util.*;

/**
 * This class contains mics utils - printDebug and notImplementedMsg.
 * 
 * 
 * @author Irwin Yoon
 */
public final class SystemUtils {

    /**
     * Print out timestamp for debugging.
     * @param msg
     */
    public static void printDebug(String msg) {
    
        DateFormat f = new SimpleDateFormat("MM/dd/yy HH:mm:ss");
        Date timestamp = Calendar.getInstance().getTime();
	    System.out.println("DEBUG " + f.format(timestamp) + ": " + msg);
	    
    }

    /**
     * If a feature has not been implemented, print out error
     * message.
     * @param feature
     */
    public static void notImplementedMsg(String feature) {
        System.out.println("TO BE IMPLEMENTED: " + feature);
    }
}
