package org.recommender.test;

import org.recommender.server.ItemPrediction;
import org.recommender.server.CFException;
import org.recommender.server.CFEngine;

import java.rmi.RemoteException;

/**
 * Created by 
 * User: herlock
 * Date: May 10, 2003
 * Time: 8:15:51 PM
 */

/**
 * Thread class that will actually hit the recommender server with
 * only recommendation requests.
 */
public class RandomTopNThread extends TesterThread {

    public RandomTopNThread(CFEngine cfengine, String threadName, int minUserid, int maxUserid, int count) {
        super(cfengine, threadName, minUserid, maxUserid, count);
    }

    /**
     * Main method for this thread. This will grab count recommendations
     * for users between minUserid and maxUserid, picking a random userid
     * each time.
     */
    public void run() {
        long startTime = System.currentTimeMillis();
        for (int i = 0; i < count; i++) {
            // Pick a random userid between minUserid and maxUserid
            int userid = (int) (minUserid + ((maxUserid - minUserid) * Math.random()));

            try {
                ItemPrediction[] ret = cfengine.getRecommendations(userid, 10, 0);
            } catch (RemoteException e) {
                e.printStackTrace();
                fatalError();
            } catch (CFException e) {
                e.printStackTrace();
                fatalError();
            }
	    //            System.out.print("T");
        }

        System.out.println(" total number of recommendations = " + count);
        long stop = System.currentTimeMillis();
        long length = (stop - startTime);
        System.out.println("Total prediction time = " + length + "ms\n\n");
        // preds/s
        float rate = count / ((float) length / 1000);
        System.out.println("Rate: " + rate + " topNs per second");

        System.out.println("Exiting child thread.");
    }
}
