/* 
 * ClacUserInfo.java
 * 
 * Version 1.1
 * 
 * 05/31/2002
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */ 

package org.recommender.util;

import java.io.*;
import java.sql.*;
import java.util.*;
import java.net.*;
import java.lang.Math.*;
import org.recommender.server.*;

/**
 * 
 * This set of scripts will be use to construct a framework
 * for experiments on Recommender Systems. The purpose of these
 * experiments is to determine how sampling user ratings affects
 * the accuracy and item coverage of a recommender system.
 *
 * This class takes the samling mode as a parameter and proceeds  
 *
 * @author  (<A HREF="mailto:godde@cs.orst.edu">Olivier Godde</A>)
 * @since   JDK 1.2
 * @version Version 1.0.0, 05-31-2002
 *
 */
 

public class CalcUserInfo{

	
	public static void main(String args[]) throws java.sql.SQLException, IOException{
		
		
		String samplingMode= args[0];
		
		//String installdir = System.getProperty("cf.path",".");
		//SystemProperties.loadProperties(installdir + "/lib/CFServer.properties");
		long start = System.currentTimeMillis();
		
		if (samplingMode.equals("entropy")){
			ComputeEntropy ent = new ComputeEntropy();
			ent.doComp();
		} else if (samplingMode.equals("iuf")){
			ComputeIUF iuf = new ComputeIUF();
			iuf.doComp();
		} else
			System.out.println("ERROR: sampling mode unknown");
		long stop = System.currentTimeMillis();
		System.out.println("Exiting CalcUserInfo. Total " + (stop - start) + "ms");
	}
}
