/* 
 * ConvertMLItemData.java
 * 
 * Version 1.1
 * 
 * 01/19/2003
 *
 * Copyright (c) 2003 Oregon State Universtity. All rights reserved.
 */ 

package org.recommender.util;

import java.sql.*;
import java.io.*;
import java.util.*;
  
/**
 * 
 * This set of scripts will create a data file by retrieving fields from
 * the Grouplens' data file.   
 *
 * This class retrieves item number and types for each item.
 *
 * @author  (<A HREF="mailto:wangyun@cs.orst.edu">Yun Wang</A>)
 * @since   JDK 1.2
 * @version Version 1.0.0, 01-19-2003
 *
 */


public class ConvertMLItemData
{
  // private String expDir="/nfs/spectre/u10/collab/wangyun/moviedata/ml-data";
   private String expDir;
   
   public ConvertMLItemData(String dir)
   {
       expDir = dir;
   }
      
   
    private void retrievTypeData(String infile, String outfile)
    {
        File outputFile = new File(expDir + "/" + outfile);
        FileReader fin = null;
        FileWriter fout = null;
        
        try{ 
		   fin = new FileReader(expDir + "/" + infile);
		   		    
	    } catch (java.io.FileNotFoundException ex){ 
		   System.out.println("ERROR:input file not found"); 
	    }
	    
	    try {
	       fout = new FileWriter(outputFile);
	    } catch (java.io.IOException ex){ 
		   System.out.println("ERROR:out file not found"); 
	    }   
	    
	    
	    StringTokenizer token= null;  
        try {
           BufferedReader in= new BufferedReader(fin);
           
           BufferedWriter out = new BufferedWriter(fout); 
           
           String line;
           while ((line = in.readLine()) != null) {
               token = new StringTokenizer(line,"|");
           
              // boolean first = true;
           
               int item =(new Integer(token.nextToken())).intValue();
              // System.out.println(item);
               
               int type = -1;
          
               while (token.hasMoreTokens())
              {
                   String c = token.nextToken();
                   
                   if (c == null)
                      continue;
                   if (c.length() > 1)
                      continue;
                   //if (c != "0" && c != "1")
                   //    continue;
                     
             //  System.out.print(c +" "); 
                   type +=1;
                   
                   int i = (new Integer(c)).intValue(); 
               
                  if (i == 1)
                  {
                     out.write(item + "\t" + type);
                   //  System.out.println(item + "|" + type + "\n");
                     out.newLine();
                  }
               }
               
            }
            
            System.out.println();
            in.close();
            out.close();
         } catch(java.io.IOException ex){
         
            System.out.println("ERROR:" + ex); 
         
         }
         
     }
     
     
     public static void main(String[] args) throws IOException 
     {
          String dir = args[0];
          ConvertMLItemData l = new ConvertMLItemData(dir);
          l.retrievTypeData("u.item", "itemtype.txt");
      }
      
 }

     
        
             
           
           